#include <conio.h>
#include <iostream.h>
#include <stdio.h>
#include <ctype.h>
#include <assert.h>
#include <stdlib.h>
#include <time.h>

#include "21qbase.hpp"
#include "21qfile.h"
#include "response.h"

#define VERSION				"1.00"

void credits();

extern long answers;

int main(int nargs, char *args[])
{
	Question root(0,"");
	TreeItem *cur = &root;
	Question *prev;
	char ans[ALEN],q[QLEN],corans,dummy;
	Answer *newans, *oldans;
	Question *newq;

	credits();
	randomize();
	loadfile(&root,nargs,args);

	top:
	while(cur->isA()==QUESTION)
	{
		prev = (Question*)cur;
		cur = cur->ask();
	}

	cur->ask();
	if(toupper(getch())=='N') {
		cout << "No\n" << reveal[random(MAX_RESP_REVEAL)] << endl;
		cin.get(ans,ALEN);
		cin.get(dummy);
		cout << addword[random(MAX_RESP_ADDWORD)];
		if(toupper(getch())=='Y') {
			cout << "Yes\n" << newques[random(MAX_RESP_NEWQ)] << endl
				 << cur->gettext() << " and " << ans << ":\n";
			cin.get(q,QLEN);
			cin.get(dummy);
			dummy = random(MAX_RESP_COR);
			cout << coranspre[dummy] << ans << coranspost[dummy];
			do
				corans = toupper(getch());
			while(corans!='N' && corans!='Y');
			cout << (corans=='Y' ? "Yes\n" : "No\n");
			newq = new Question(cur->father(),q);
			newans = new Answer(newq,ans);
			if(corans=='Y') {
				newq->setyes(newans);
				newq->setno(cur);
			} else {
				newq->setyes(cur);
				newq->setno(newans);
			}
			if(prev->yeschild() == cur)
				prev->setyes(newq);
			else
				prev->setno(newq);
		} else
			cout << "No\n";
	} else
		cout << "Yes\n";

	cout << again[random(MAX_RESP_AGAIN)];
	if(toupper(getch())=='N')
		cout << "No\n";
	else
	{
		cout << "Yes\n";
		cur = &root;
		goto top;
	}
	cout << save[random(MAX_RESP_SAVE)];
	do switch(toupper(getch()))
	{
		case 'N': cout<<"No\n"; exit(0);
		case 'Y': cout<<"Yes\n";  savefile(&root); exit(0);
	} while(1);
}

void credits()
{
	cout << "21 Questions" << endl
#	ifdef SHAREWARE
		 << "SHAREWARE Version " << VERSION << endl
		 << "By Zvika Ben-Haim" << endl
		 << "To get the full version, write e-mail to zvikabh@aluf.technion.ac.il." << endl
		 << "This version may be freely distributed, but is limited to 150 terms per file." << endl << endl;
#	else
		 << "REGISTERED Version " << VERSION << endl
		 << "By Zvika Ben-Haim" << endl << endl;
#	endif
}
