#include "21qbase.hpp"
#include "response.h"

Question::Question(TreeItem* f, const char* txt) : TreeItem(f)
{
	strcpy(text,txt);
	yes_=no_=0;
}

TreeItem* Question::ask()
{
	cout << text << ' ';
	do switch(toupper(getch()))
	{
		case 'Y':
			cout << "Yes\n";
			return yes_;
		case 'N':
			cout << "No\n";
			return no_;
	} while(1);
}

TreeItem* Answer::ask()
{
	int i = random(MAX_RESP_GUESS);
	cout << guesspre[i] << text << guesspost[i] << endl;
	return this;
}

